"""
iiiiCarlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecución de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento
Al final se imprimen los promedios de cada algortimo
"""
from random import randint
import time

def mergeSort(lista):
        #Camila Vazquez Rodriguez 
	#definan el algoritmo de ordenamiento mergesort
        if len(lista) > 1:
                mid = len(lista)//2
                L = lista[:mid]
                R = lista[mid:]

                mergeSort(L)
                mergeSort(R)

                i = 0
                j = 0
                k = 0

        while i < len(L) and j < len(R):
                if L[i] <= R[j]:
                        lista[k] = L[i]
                        i += 1
                else:
                        lista[k] = R[j]
                        j += 1
                k += 1
 
        while i < len(L):
                lista[k] = L[i]
                i += 1
                k += 1
 
        while j < len(R):
                lista[k] = R[j]
                j += 1
                k += 1
                
        return lista

def heapSort(lista):
	#definan el algoritmo de ordenamiento heapsort
	"""
	Carlos Hernández
	Implementación de heapSort.
	"""
	def max_heapify(lista, idx, heap_size):
		"""Convertir el nodo `idx` y sus descendientes en un max heap."""
		left_idx = 2 * idx + 1
		right_idx = 2 * idx + 2
		largestval_idx = idx
		if left_idx < heap_size and lista[idx] < lista[left_idx]:
			largestval_idx = left_idx
		if right_idx < heap_size and lista[largestval_idx] < lista[right_idx]:
			largestval_idx = right_idx
		if largestval_idx != idx:
			lista[idx], lista[largestval_idx] = lista[largestval_idx], lista[idx]
			max_heapify(lista, largestval_idx, heap_size)

	def build_max_heap(lista, heap_size):
		"""Construir un max heap the un heap dado."""
		for idx in range((heap_size - 1) // 2, -1, -1):
			max_heapify(lista, idx, heap_size)

	heap_size = len(lista)
	build_max_heap(lista, heap_size)
	for idx in range(len(lista) - 1, 0, -1):
		lista[0], lista[idx] = lista[idx], lista[0]
		heap_size -= 1
		max_heapify(lista, 0, heap_size)
	return lista

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista

def shellSort(lista):
	#definan el algoritmo de ordenamiento shellsort
	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 #define el largo de las listas a ordenar
veces=100 		#define las veces que se va a hacer el ordenamiento

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	lista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar

	t1 = time.clock() 				#seteamos el tiempo al empezar
	mergeSort(lista) 				#ejecutamos el algoritmo mergeSort
	acumulaMerge+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	heapSort(lista)					#ejecutamos el algoritmo heapSort
	acumulaHeap+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	quickSort(lista)				#ejecutamos el algoritmo quickSort
	acumulaQuick+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

	t1 = time.clock()				#seteamos el tiempo al empezar
	shellSort(lista)				#ejecutamos el algoritmo shellSort
	acumulaShell+=time.clock()-t1 	#acumulamos el tiempo de ejecucion

#imprimos los resultados
print "Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista)
print "MergeSort " + str(acumulaMerge/veces) + " segundos"
print "HeapSort " + str(acumulaHeap/veces) + " segundos"
print "QuickSort " + str(acumulaQuick/veces) + " segundos"
print "ShellSort " + str(acumulaShell/veces) + " segundos"

